//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  LimeGreen
#property indicator_color2  Red
#property indicator_color3  LimeGreen
#property indicator_color4  Red
#property indicator_width1  1
#property indicator_width2  1
#property indicator_width3  2
#property indicator_width4  2

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern int    MaPrice         = 0;
extern double MaLength        = 10;
extern int    MaMode          = MODE_SMA;
extern int    AtrLength       = 6; 
extern double Kv              = 4;  
extern double MoneyRisk       = 1; 

extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;
extern string soundfile       = "alert2.wav"; 

//
//
//
//
//

double volhu[];
double volhd[];
double volhbu[];
double volhbd[];
double smax[];
double smin[];
double trend[];

//
//
//
//
//

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
      SetIndexBuffer(0,volhu);  SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,volhd);  SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,volhbu); SetIndexStyle(2,DRAW_HISTOGRAM);
      SetIndexBuffer(3,volhbd); SetIndexStyle(3,DRAW_HISTOGRAM);
      SetIndexBuffer(4,smax);
      SetIndexBuffer(5,smin);
      SetIndexBuffer(6,trend);
      
      //
      //
      // 
      //
      //
      
      indicatorFileName = WindowExpertName();
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
       
      IndicatorShortName(timeFrameToString(timeFrame)+"  Volty Dot");
      return(0);
}
      
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { volhu[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame==Period())
   {
      for (i=limit; i>=0; i--)
      { 
         if (MaPrice==2 || MaPrice==3)
         {
            double bprice = iMA(NULL,0,MaLength,0,MaMode,PRICE_HIGH,i);
            double sprice = iMA(NULL,0,MaLength,0,MaMode,PRICE_LOW, i);
         }
         else
         {
            bprice = iMA(NULL,0,MaLength,0,MaMode,MaPrice,i);
            sprice = iMA(NULL,0,MaLength,0,MaMode,MaPrice,i);
         }
         
         smin[i]  = sprice - Kv * iATR(NULL,0,AtrLength,i); 
         smax[i]  = bprice + Kv * iATR(NULL,0,AtrLength,i);
         trend[i] = trend[i+1]; 
   
         //
         //
         //
         //
         //
         
	      if (bprice > smax[i+1]) trend[i] =  1;
         if (sprice < smin[i+1]) trend[i] = -1;
	      if (trend[i] > 0 && smin[i] < smin[i+1]) smin[i] = smin[i+1];
	      if (trend[i] < 0 && smax[i] > smax[i+1]) smax[i] = smax[i+1];
         if (trend[i] == 1)
         {
            volhu[i]  = High[i]; 
            volhd[i]  = Low[i];
            volhbu[i] = MathMax(Open[i],Close[i]);
            volhbd[i] = MathMin(Open[i],Close[i]);
         }               
         if (trend[i] == -1)
         {
            volhu[i]  = Low[i];
            volhd[i]  = High[i];
            volhbu[i] = MathMin(Open[i],Close[i]);
            volhbd[i] = MathMax(Open[i],Close[i]);
         }               
      }
      manageAlerts();
      return(0);
   }
      
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit;i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         trend[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MaPrice,MaLength,MaMode,AtrLength,Kv,MoneyRisk,6,y);
         if (trend[i] == 1)
         {
            volhu[i]  = High[i]; 
            volhd[i]  = Low[i];
            volhbu[i] = MathMax(Open[i],Close[i]);
            volhbd[i] = MathMin(Open[i],Close[i]);
         }               
         if (trend[i] == -1)
         {
            volhu[i]  = Low[i];
            volhd[i]  = High[i];
            volhbu[i] = MathMin(Open[i],Close[i]);
            volhbd[i] = MathMax(Open[i],Close[i]);
         }               
   }
   manageAlerts();  
   return(0);         
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
return(s);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (! calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"buy");
         if (trend[whichBar] ==-1) doAlert(whichBar,"sell");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",timeFrameToString(timeFrame)+" Volty Candles ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Volty Candles "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}


